//   
//  
// : O(x*y)
//      O(x)
//
// p.s.        ( ).

#include<stdio.h>
#include<string.h>
#include<malloc.h>
#include<stdlib.h>
#include<windows.h>

#define XSIZE 70
#define YSIZE 70

#ifdef WIN32
#  define Check(b) if(b) _asm{int 3}
#else
#  define Check(b)
#endif

char str1[XSIZE+1],str2[YSIZE+1];	//  
char res1[XSIZE+1],res2[XSIZE+1];	// 

#define PATH_LEFT	1 //  (    
#define PATH_UP		2
#define PATH_DIG	3


int matrix[XSIZE];	//     (  )
int path[XSIZE];	//    (..      )

//    (  )
int Eval(int x1,int x2,int y1,int y2)
{
	int x,y,t;
	int l,u,lu;	//      
	int old,old_index;
	if(x1==x2) return 0;
	for(x=x1; x<x2; x++) path[x]=x;
	for(y=y1; y<y2; y++) { //   
	old=0; old_index=-1;
	for(x=x1; x<x2; x++) {
		if(x>x1) l=matrix[x-1]; else l=0;
		lu=old,u=matrix[x]; 
		t=old_index; old_index=path[x];
		if(str1[x]==str2[y]) l=lu+1,path[x]=t;
		else if(u>l) l=u; else if(x) path[x]=path[x-1]; else path[x]=-1;
		old=matrix[x],matrix[x]=l;
	}

	}
	return matrix[x2-1];
}


//  ( )
void SubMilk(int x1,int x2,int y1,int y2)
{
	int n,max,i,j;
	i=(y1+y2)/2;
	if(y1>=y2 || x1==x2) return;
	if(y2-y1==1) {
		for(n=x1; n<x2; n++) if(str1[n]==str2[y1]) {res1[n]=res2[y1]='+';break;}
		return;	
	}
	memset(matrix,0,sizeof(matrix));
	Eval(x1,x2,y1,i);
	Eval(x1,x2,i,y2);
	max=j=-1; j=path[x2-1]+1;
	if(j<x1) j=x1;
	Check(j<x1 || j>x2);
	SubMilk(x1,j,y1, i);
	SubMilk(j,x2, i,y2);
}

//  ( )
int Work()
{
	int n,m;
	for(n=0; str1[n]; n++) res1[n]='-'; res1[n]=0;
	for(n=0; str2[n]; n++) res2[n]='-'; res2[n]=0;
	SubMilk(0,strlen(str1),0,strlen(str2));
	for(n=m=0; res1[n]; n++) if(res1[n]=='+') m++;
	printf("\n%s\n%s\n%s\n%s\n",str1,res1,str2,res2);	// 
	return m;
}


//      .  O(x*y)
int Test(int x1,int x2,int y1,int y2)
{
	int x,y,l,u,lu; 
	int matrix[XSIZE+1][YSIZE+1]; //   (   )
	memset(matrix,0,sizeof(matrix));
	for(x=x1; x<x2; x++) for(y=y1; y<y2; y++)  //   
	{
		if(x>x1 || y>y1)
		{ 
			if(x>x1 && y>y1) lu=matrix[x-1][y-1]; 
			if(x>x1) l=matrix[x-1][y]; else l=lu=0;
			if(y>y1) u=matrix[x][y-1]; else u=lu=0;
		} else l=u=lu=0;
		if(u>l) l=u;
		if(str1[x]==str2[y]) l=lu+1; 
		matrix[x][y]=l;
	}
	return matrix[x2-1][y2-1];
}



void main()
{
	int a,b;
	strcpy(str1,"5101288315522941386400909759230348706889224071505030766130651544833896");
	strcpy(str2,"4396963654209401016377222796661603754170409899191733399308153900614282");
	a=Test(0,strlen(str1),0,strlen(str2));
	b=Work();
	if(a!=b) printf("Error !!!\n\a");
}



